



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>commons-dbutils 字段名称转换</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">commons-dbutils 字段名称转换</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 19:06:31 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<blockquote><p>我们在写bean的时候,字段通常都使用小驼峰命名法,但是在设计数据库时,一般使用下划线分割命名.这样,在取出数据库字段时,还需要转换.如何简洁的实现这种转换呢?</p></blockquote>
<p>你能遇到的问题,只要是普遍存在的,大家都会遇到,那么,就一定有现成的解决方案.</p>
<p>在阅读 <code>commons-dbutils</code> 的文档时, <code>BeanHandler</code> 的第二个参数可以达到这个目的.只需传入一个实现 <code>RowProcessor</code> 接口的对象. 比如说 <code>BasicRowProcessor</code>:</p>
<p><code>User user = queryRunner.query(conn,sql,new BeanHandler&lt;User&gt;(User.class, new BasicRowProcessor());</code></p>
<p>这样做还不够,你还没有告诉<code>BasicRowProcessor</code>怎样处理字段的映射关系,可以给 <code>BasicRowProcessor</code> 的构造函数传入一个<code>BeanProcessor</code> ,给这个<code>BeanProcessor</code>传入一个<code>Map</code>,指定数据库字段和<code>bean</code>字段的映射关系.</p>
<p><code>Map&lt;String,String&gt; map = new HashMap&lt;&gt;();  map.put("user_id","userId");  User user = queryRunner.query(conn,sql,new BeanHandler&lt;User&gt;(User.class, new BasicRowProcessor(new BeanProcessor(map))));</code></p>
<p>这样就可以将数据中的 <code>user_id</code> 映射到 <code>bean</code> 上的 <code>userId</code> 了.</p>
<p>仔细阅读文档,发现官方已经贴心的为你设计好了一个类,专门干这种事的,叫做 <code>GenerousBeanProcessor</code> ,这下简单了,不再需要什么 <code>map</code> 了.只要你的数据库字段名称和<code>bean</code>中的字段名称除了下划线和大小写都一样的话,用它就可以转换:</p>
<p><code>User user = queryRunner.query(conn,sql,new BeanHandler&lt;User&gt;(User.class, new BasicRowProcessor(new GenerousBeanProcessor())));</code></p>
<p>大功告成!</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m8z3g0xq.html">成功部署SSIS中含有Oracle数据库连接的ETL包</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mkl36q.html">Nginx配置文件（nginx&period;conf）配置详解&lpar;2&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwe2gyq.html">允许FTP用户登录并禁止Shell登录的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql0n3eq.html">C&num; 路径</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kgzj59.html">判断表字段是否存在default约束</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8m5y46q.html">UI组件之Group</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mndnk2q.html">JS 学习笔记--JS中的事件对象基础</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z14gyn9.html">Python脚本控制的WebDriver 常用操作 &amp;lt&semi;二十&amp;gt&semi; 处理表单元素</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ok3ywx9.html">Kill Session</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vkr1m8.html">看文档要看仔细，英语要加强啊&period;&period;&period;  cocos2d-x 的 API 和 对应版本的 cocos2d-js 的 API 没有完全对应</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rde1678.html">过滤ASCII码中的不可见字符&comma; ASCII三部分&comma; 各控制字符详解&comma; 去&Hat;&commat;&comma;&Hat;M</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mn35w2q.html">PO VO DAO DTO BO TO概念与区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjl4d38.html">C&num; 语言规范&lowbar;版本5&period;0 &lpar;第13章 接口&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpjr5vq.html">让IE6 IE7 IE8 IE9 IE10 IE11支持Bootstrap的解决方法 转载</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1rl3xq.html">bootstrap之daterangepicker---汉化以及扩展</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1dg6xq.html">php分割中文字符串为数组的简单例子</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdev7v9.html">FastJson 支持配置的PropertyNamingStrategy四种策略</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gzn6mq.html">Python全栈之路----函数----嵌套函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2yokrq.html">mysql5&period;7&period;18&period;1修改用户密码报错ERROR 1054 &lpar;42S22&rpar;&colon; Unknown column &amp;&num;39&semi;password&amp;&num;39&semi; in &amp;&num;39&semi;field list&amp;&num;39&semi;解决办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pw5wx78.html">Kafka 1&period;1新功能：数据的路径间迁移</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8oj24elq.html">db2 update   异常</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zolkm3q.html">Unix：关于一个file在file system和disk中占用空间</a>
			</li>
						<li><a href="https://www.batexi.com/a/93y6p0g8.html">Java 封装 HDFS API 操作</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4z64jj9.html">SpringBoot 整合Ehcache3</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdpx54vq.html">11g使用非duplicate方式创建物理standby要注意的问题总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2j60238.html">注册Azure AD 2&period;0 应用程序</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpdvr69.html">es6&plus;require混合开发，兼容es6 module，import&comma;export之 加载css及公用date-main</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv17k11q.html">Material使用02 图标MdIconModule、矢量图作为图标使用及改进</a>
			</li>
						<li><a href="https://www.batexi.com/a/8eyxwnj9.html">Flink升级到1&period;4版本遇到的坑</a>
			</li>
						<li><a href="https://www.batexi.com/a/93y675w8.html">SparkStreaming读取Kakfa数据时发生OffsetOutOfRangeException异常</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
